package modelo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.22A338A1-D880-8835-2987-4419EADE8E03]
// </editor-fold> 
@Entity
@Table (name = "CasoUso")
public class CasoUso extends ElementosTrazas implements Serializable {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.A3EFEE89-8214-EFE6-BC6B-16D652F1731F]
    // </editor-fold> 
    @Id
    @Column (name = "identificacion")
    private String identificacion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C94CF3CA-A59D-5EB6-3E7F-45AE6D00F5D2]
    // </editor-fold> 
    @Column (name = "nombre")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.61E8B50B-0C62-9591-29F1-571CF014ABF8]
    // </editor-fold> 
    @Column (name = "version")
    private String version;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.29B4449A-1465-3B60-6A2D-C4891016A1A5]
    // </editor-fold> 
    @Temporal(javax.persistence.TemporalType.DATE)
    private Date fecha;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5FD0021B-F05B-0074-1804-1340365EC01C]
    // </editor-fold> 
    @Transient
    private List<Participante> autores;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.838F0E46-1E52-2B99-C3A8-46C17CC0C920]
    // </editor-fold> 
    @Transient
    private List<Participante> fuentes;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.1AD669DB-A1B0-8C7D-4443-EF37243EB6FD]
    // </editor-fold> 
    @Column (name = "esAbstracto")
    private Boolean esAbstracto;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CCB6C3B5-ECFB-6D38-AD9A-D0A7C4E8F6E6]
    // </editor-fold> 
    @Column (name = "eventoActivacion")
    private String eventoActivacion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8A46DB81-922B-F158-8046-3946E3DA73CB]
    // </editor-fold> 
    @Column (name = "veces")
    private int veces;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.27D6221A-7204-47D3-72B0-E733F8DC6A68]
    // </editor-fold> 
    @Column (name = "unidad")
    private String unidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.EC1AD46E-EF1F-AC24-1AD3-6E3C1322A6E7]
    // </editor-fold> 
    @Column (name = "precondicion")
    private String precondicion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FD158C5D-3ADC-7113-3F57-26ECC91742BE]
    // </editor-fold> 
    @Column (name = "postcondicion")
    private String postcondicion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.91FF78FB-693F-8735-4800-B233308BD2D2]
    // </editor-fold> 
    @Column (name = "importancia")
    private String importancia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.A5905FE5-4CDF-CA1C-3DA0-09E68CAE3AAB]
    // </editor-fold> 
    @Column (name = "urgencia")
    private String urgencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2B2A0970-8952-F043-E7A6-96A194C9B010]
    // </editor-fold> 
    @Column (name = "estadoDesarrollo")
    private String estadoDesarrollo;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CAF66AC7-C127-AB98-DDA7-34C9422BCB8C]
    // </editor-fold> 
    @Column (name = "estabilidad")
    private String estabilidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.DFBA0410-0A30-660D-0528-6A5A3EF9D19B]
    // </editor-fold> 
    @Transient
    private List<ElementosTrazas> destino;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0B5E089F-7545-8A50-CAA8-FC20F26086C1]
    // </editor-fold> 
    @Transient
    private List<ElementosTrazas> origen;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F6ED5904-C2BE-3D22-437A-8544C621476A]
    // </editor-fold> 
    @Column (name = "comentario")
    private String comentario;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B4E795CB-4757-850F-EE85-6FADB30571D2]
    // </editor-fold> 
    @OneToMany(mappedBy = "mCasoUso")
    private List<Paso> mPaso;


    
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5D91167B-9C5F-B5A4-6DDC-89C240DD4F3D]
    // </editor-fold> 
    public CasoUso () {
        fecha = new Date();
        autores = new ArrayList<Participante>();
        fuentes = new ArrayList<Participante>();
        destino = new ArrayList<ElementosTrazas>();
        origen = new ArrayList<ElementosTrazas>();

        mPaso = new ArrayList<Paso>();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9165699D-55A9-84D0-E28E-49E47D424B2F]
    // </editor-fold> 
    public ArrayList<Participante> getAutores () {
        return (ArrayList)autores;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4B22747A-116E-CC3C-DAB3-3A6140A87F9F]
    // </editor-fold> 
    public void setAutores (ArrayList<Participante> val) {
        this.autores = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E25E2816-FA14-E19C-DAF0-998D6E911FCF]
    // </editor-fold> 
    public String getComentario () {
        return comentario;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1FFDB663-DE59-9599-278D-9B788D950323]
    // </editor-fold> 
    public void setComentario (String val) {
        this.comentario = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B755582D-4869-5892-2BE8-A65D760DBFE7]
    // </editor-fold> 
    public ArrayList<ElementosTrazas> getDestino () {
        return (ArrayList)destino;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.59478653-9BE2-423C-4FE7-D3543AF9B832]
    // </editor-fold> 
    public void setDestino (ArrayList<ElementosTrazas> val) {
        this.destino = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.AB7A1BEB-8179-875D-BB6C-6CD73791ED5C]
    // </editor-fold> 
    public Boolean getEsAbstracto () {
        return esAbstracto;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.871A2F1E-0529-E99F-D37B-442604976A5A]
    // </editor-fold> 
    public void setEsAbstracto (Boolean val) {
        this.esAbstracto = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6CBDF9FE-F04B-ADC5-2DF2-22C9CD9201EE]
    // </editor-fold> 
    public String getEstabilidad () {
        return estabilidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1E860F86-3CC3-D2A4-75DD-6D565941642A]
    // </editor-fold> 
    public void setEstabilidad (String val) {
        this.estabilidad = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.5C9E8574-65AB-214E-1009-2B0D62356FA2]
    // </editor-fold> 
    public String getEstadoDesarrollo () {
        return estadoDesarrollo;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DE60E73F-7F1D-ECEE-DF6E-B203C8FBD54A]
    // </editor-fold> 
    public void setEstadoDesarrollo (String val) {
        this.estadoDesarrollo = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.910CF0D1-0A5E-9895-CB44-EF6C8BEA6699]
    // </editor-fold> 
    public String getEventoActivacion () {
        return eventoActivacion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1F76039A-C4A2-92BE-0D00-62B13C42B993]
    // </editor-fold> 
    public void setEventoActivacion (String val) {
        this.eventoActivacion = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7D88AC60-946C-8772-EC2F-13CBA084CD30]
    // </editor-fold> 
    public Date getFecha () {
        return fecha;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B4C4DC0A-B392-09C4-A847-E2C06D891340]
    // </editor-fold> 
    public void setFecha (Date val) {
        this.fecha = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B3098D01-2DE8-575A-F471-8AA3B78710B5]
    // </editor-fold> 
    public ArrayList<Participante> getFuentes () {
        return (ArrayList)fuentes;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A15A7AB8-D596-32E9-5A3D-340B64AC062D]
    // </editor-fold> 
    public void setFuentes (ArrayList<Participante> val) {
        this.fuentes = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6B496487-7A79-7E95-149D-7400660B619F]
    // </editor-fold> 
    public String getIdentificacion () {
        return identificacion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9E2E595F-CF5C-A93B-812A-3CA818A89F13]
    // </editor-fold> 
    public void setIdentificacion (String val) {
        this.identificacion = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.334D20ED-D4D1-82AC-6CFD-2547185ABE44]
    // </editor-fold> 
    public String getImportancia () {
        return importancia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4637DE6E-87FF-1B54-813B-658B2711BFF4]
    // </editor-fold> 
    public void setImportancia (String val) {
        this.importancia = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.10B37EE6-C88B-9987-9301-BB256A96B47B]
    // </editor-fold> 
    public ArrayList<Paso> getPaso () {
        return (ArrayList)mPaso;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E1CA26C3-30DC-56F9-58AF-6231F67A2A3B]
    // </editor-fold> 
    public void setPaso (ArrayList<Paso> val) {
        this.mPaso = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E4BA17C6-6892-8E8F-F50F-D8B4302669B6]
    // </editor-fold> 
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B0389392-16F4-A705-20BE-827AD796E574]
    // </editor-fold> 
    public void setNombre (String val) {
        this.nombre = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D8EFE987-9161-0C7D-0DDB-38946BE7E3A6]
    // </editor-fold> 
    public ArrayList<ElementosTrazas> getOrigen () {
        return (ArrayList)origen;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.85F421CA-3913-5D39-0757-A0E3D898AB07]
    // </editor-fold> 
    public void setOrigen (ArrayList<ElementosTrazas> val) {
        this.origen = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.ED138559-DA71-43C0-DF36-62297B526E95]
    // </editor-fold> 
    public String getPostcondicion () {
        return postcondicion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F6CFAD76-E6D3-D52E-030C-FE4B461CA42E]
    // </editor-fold> 
    public void setPostcondicion (String val) {
        this.postcondicion = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1F819562-AA4C-FC20-5097-29C2F22C9530]
    // </editor-fold> 
    public String getPrecondicion () {
        return precondicion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E99B3F97-82FE-EB9A-39F6-CB7FCB9EA461]
    // </editor-fold> 
    public void setPrecondicion (String val) {
        this.precondicion = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E983DDD2-83A9-F957-D341-B620CB8A58CE]
    // </editor-fold> 
    public String getUnidad () {
        return unidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.89A2E0EE-6529-AB5D-852F-F2AF455C1BF5]
    // </editor-fold> 
    public void setUnidad (String val) {
        this.unidad = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.44E9AE68-CCE9-FCDA-0813-B8F7F02C09EF]
    // </editor-fold> 
    public String getUrgencia () {
        return urgencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E0371150-A866-D0EB-7414-EDBBD5DD2879]
    // </editor-fold> 
    public void setUrgencia (String val) {
        this.urgencia = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CDFFD7CC-0B1B-03F2-8F39-35E54A3D8B79]
    // </editor-fold> 
    public int getVeces () {
        return veces;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.40262944-8912-EB2A-BF11-0A7350349347]
    // </editor-fold> 
    public void setVeces (int val) {
        this.veces = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.38513245-34B1-B300-62CB-410DB65B9CD9]
    // </editor-fold> 
    public String getVersion () {
        return version;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.ECF52C77-69AC-E60E-2E83-DD7DECE10B69]
    // </editor-fold> 
    public void setVersion (String val) {
        this.version = val;
    }

    public Paso nuevoPaso (Paso paso) {
        this.getPaso().add(paso);
        guardarEnBaseDatos(paso);
        
        return paso;
    }
    
    @Override
    public String toString() {
        return "CasoUso{" + "identificacion=" + identificacion + ", nombre=" + nombre + ", version=" + version + ", fecha=" + fecha +
                ", esAbstracto=" + esAbstracto + ", eventoActivacion=" + eventoActivacion + ", veces=" + veces + ", unidad=" + unidad +
                ", precondicion=" + precondicion + ", postcondicion=" + postcondicion + ", importancia=" + importancia + ", urgencia=" +
                urgencia + ", estadoDesarrollo=" + estadoDesarrollo + ", estabilidad=" + estabilidad + ", comentario=" + comentario +
                ", mPaso=" + mPaso + '}';
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final CasoUso other = (CasoUso) obj;
        if ((this.identificacion == null) ? (other.identificacion != null) : !this.identificacion.equals(other.identificacion)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 83 * hash + (this.identificacion != null ? this.identificacion.hashCode() : 0);
        return hash;
    }

    public static CasoUso getData (String id) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("AZETA_REMPU");
        EntityManager em = emf.createEntityManager();
        Query q = em.createQuery("SELECT cu FROM CasoUso cu WHERE cu.identificacion = '"+ id +"'");

        CasoUso casoUso = (CasoUso) q.getSingleResult();

        return casoUso;
    }

    public void guardarEnBaseDatos (Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("AZETA_REMPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();

        try {
            em.persist(object);
            em.getTransaction().commit();

        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();

        } finally {
            em.close();
        }
    }

}

